/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only&&"GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package build;

import java.io.InputStream;
import java.net.InetSocketAddress;
import java.net.Proxy;
import java.net.URL;
import java.net.URLConnection;
import java.util.StringTokenizer;

/**
 * @author Vladimir Yaroslavskiy
 * @version 2007.08.28
 */
public class build {
  public static final void main(String [] arg) {
    StringBuffer buffer = new StringBuffer();
    boolean useProxy = !"false".equals(System.getProperty("netbeans-prox"));
    String type = System.getProperty("netbeans-type");
//  String type = "javaee";

    try {
//    URL url = new URL("http://smetiste.czech.sun.com/builds/netbeans/6.1/fixes/latest/zip");
//    URL url = new URL("http://deadlock.netbeans.org/hudson/job/trunk/lastSuccessfulBuild/artifact/nbbuild/dist/zip");
      URL url = new URL(System.getProperty("netbeans-link"));

      byte [] buf = new byte [102324];
      InputStream is = url.openStream();

      if (useProxy) {
        URLConnection connection = url.openConnection(new Proxy(Proxy.Type.HTTP, new InetSocketAddress("webcache.sfbay.sun.com", 8080)));
        is = connection.getInputStream();
      }
      else {
        is = url.openStream();
      }
      while (true) {
        int readed = is.read(buf);

        if (readed == -1) {
          break;
        }
        buffer.append(new String(buf));
      }
      is.close();
    }
    catch (Exception e) {
      e.printStackTrace();
      return;
    }
    String value = buffer.toString();
    value = replace(value, "</tr><tr>", "\n");

    StringTokenizer stk = new StringTokenizer(value, "\n");

    while (stk.hasMoreTokens()) {
      String line = stk.nextToken();

      if ( !line.contains(ZIP)) {
        continue;
      }
      if ( !line.contains("=\"netbeans-")) {
        continue;
      }
//System.out.println();
//System.out.println(" see: " + line);
      if (ALL.equals(type)) {
        if (isPack(line)) {
          continue;
        }
      }
      else {
        if ( !isType(line, type)) {
          continue;
        }
      }
//System.out.println("this: " + line);
      System.out.println(getBuildName(line));

      return;
    }
    System.out.println(UNKNOW);
  }

  private static String getBuildName(String line) {
    int end = line.indexOf(ZIP);
    int begin = end;

    if (begin == -1) {
      return UNKNOW;
    }
    while (true) {
      begin--;

      if (begin < 0) {
        return UNKNOW;
      }
      if (line.charAt(begin) == '"') {
        break;
      }
    }
    return line.substring(begin + 1, end + ZIP.length() - 2);
  }

  private static boolean isPack(String line) {
    for (String pack : PACKS) {
      if (line.contains(MINUS + pack + ZIP)) {
        return true;
      }
    }
    return false;
  }

  private static boolean isType(String line, String type) {
    for (String pack : PACKS) {
      if (pack.equals(type) && line.contains(MINUS + pack + ZIP)) {
        return true;
      }
    }
    return false;
  }

  private static String replace(String source, String searchFor, String replaceWith) {
    if (source == null) {
      return null;
    }
    if (searchFor == null || searchFor.length() == 0) {
      return null;
    }
    int k = 0;
    int found = source.indexOf(searchFor, k);
    StringBuffer buffer = new StringBuffer();

    while (true) {
      if (found == -1) {
        break;
      }
      buffer.append(source.substring(k, found));
      buffer.append(replaceWith);

      k = found + searchFor.length();
      found = source.indexOf(searchFor, k);
    }
    if (k > 0) {
      buffer.append(source.substring(k));
      return buffer.toString();
    }
    else {
      return source;
    }
  }

  private static final String UNKNOW = "???"; 
  private static final String ZIP = ".zip\">"; 
  private static final String MINUS = "-"; 

  private static final String ALL = "all";

  private static final String CND = "cnd";
  private static final String CPP = "cpp";
  private static final String JAVA = "java";
  private static final String JAVAEE = "javaee";
  private static final String JAVASE = "javase";
  private static final String JAVADOC = "javadoc";
  private static final String MOBILITY = "mobility";
  private static final String PHP = "php";
  private static final String PLATFORM = "platform";
  private static final String PLATFORM_SRC = "platform-src";
  private static final String RUBY = "ruby";
  private static final String SRC = "src";

  private static final String [] PACKS = new String [] {
    CND,
    CPP,
    JAVA,
    JAVAEE,
    JAVASE,
    JAVADOC,
    MOBILITY,
    PHP,
    SRC,
    PLATFORM,
    PLATFORM_SRC,
    RUBY,
  };
}
